<template>
  <v-row>
    <v-col>
      <v-menu
        ref="menu3"
        :close-on-content-click="false"
        v-model="menu3"
        :return-value.sync="years1"
        :nudge-right="40"
        lazy
        transition="scale-transition"
        offset-y
        full-width
        min-width="290px"
      >
        <template v-slot:activator="{ on, attrs }">
          <v-text-field
            v-model="years1"
            label="ปีที่เริ่ม (พ.ศ.)"
            prepend-inner-icon="mdi-calendar"
            readonly
            outlined
            rounded
            v-bind="attrs"
            v-on="on"
          ></v-text-field>
        </template>
        <v-date-picker
          ref="picker3"
          v-model="years1"
          @input="saveYear1"
          reactive
          no-title
        ></v-date-picker>
      </v-menu>
    </v-col>
    <v-col>
      <v-menu
        ref="menu4"
        :close-on-content-click="false"
        v-model="menu4"
        :nudge-right="40"
        :return-value.sync="years2"
        lazy
        transition="scale-transition"
        offset-y
        full-width
        min-width="290px"
      >
        <template v-slot:activator="{ on, attrs }">
          <v-text-field
            v-model="years2"
            label="ปีที่จบ (พ.ศ.)"
            prepend-inner-icon="mdi-calendar"
            readonly
            outlined
            rounded
            v-bind="attrs"
            v-on="on"
          ></v-text-field>
        </template>
        <v-date-picker
          ref="picker4"
          v-model="years2"
          @input="saveYear2"
          reactive
          no-title
        ></v-date-picker> </v-menu
    ></v-col>
  </v-row>
</template>

<script>
import moment from "moment";
export default {
  data() {
    return {
      years1: null,
      years2: null,
      menu3: false,
      menu4: false,
      arrY: [],
    };
  },
  created() {
    this.defaultYear();
    this.$emit("update:inputYear", this.arrY);
  },
  watch: {
    menu3(val) {
      val && this.$nextTick(() => (this.$refs.picker3.activePicker = "YEAR"));
    },
    menu4(val) {
      val && this.$nextTick(() => (this.$refs.picker4.activePicker = "YEAR"));
    },
  },
  methods: {
    daysInMonth(month, year) {
      return new Date(year, month, 0).getDate();
    },
    saveYear1(date) {
      this.arrY = [];
      let fullDate = `${date}`.split("-");
      let year = fullDate[0];
      this.arrY[0] = `${year}-01`;
      let calYear = parseInt(year) + 6;
      let newYear = `${calYear}-01`;
      this.arrY.push(newYear);
      this.$emit("update:inputYear", this.arrY);
      this.years1 = year;
      this.years2 = `${calYear}`;
      this.$refs.menu3.save(this.years1);
      this.$refs.picker3.activePicker = "YEAR";
      this.menu3 = false;
    },
    saveYear2(date) {
      this.arrY = [];
      let fullDate = `${date}`.split("-");
      let year = fullDate[0];
      this.arrY[1] = `${year}-01`;
      let calYear = parseInt(year) - 6;
      let newYear = `${calYear}-01`;
      this.arrY[0] = newYear;
      this.$emit("update:inputYear", this.arrY);
      this.years1 = `${calYear}`;
      this.years2 = year;
      this.$refs.menu4.save(this.years2);
      this.$refs.picker4.activePicker = "YEAR";
      this.menu4 = false;
    },
    defaultYear() {
      let fullDate = moment(this.$options.filters.dateNow())
        .add(543, "year")
        .format("YYYY-MM")
        .split("-");
      this.arrY[1] = fullDate;
      let year = fullDate[0];
      let calYear = parseInt(year) - 6;
      let newYear = moment(`${calYear}-${fullDate[1]}`).format("YYYY-MM");
      this.arrY[0] = newYear;
      this.years1 = `${calYear}`;
      this.years2 = fullDate[0];
    },
  },
};
</script>

<style></style>
